addHook("PlayerThink", function(player)
      if player.valid and player.playerstate == PST_LIVE
         if player.mo.skin == "sonic"
         and (player.pflags & PF_JUMPED)
		 and (player.cmd.buttons & BT_CUSTOM1)
		 and not (player.powers[pw_underwater])
            local springspawn = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_YELLOWSPRING)
	        springspawn.target = player.mo
			springspawn.fuse = TICRATE
	        springspawn.dissappear = TICRATE
	        springspawn.angle = player.drawangle
         end
	 end
end)


addHook("PlayerThink", function(player)
      if player.valid and player.playerstate == PST_LIVE
         if player.mo.skin == "sonic"
         and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		 and (player.cmd.buttons & BT_CUSTOM1)
		 and not (player.powers[pw_underwater])
            local redspringspawn = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_REDSPRING)
	        redspringspawn.target = player.mo
			redspringspawn.fuse = TICRATE
	        redspringspawn.dissappear = TICRATE
	        redspringspawn.angle = player.drawangle
         end 
	 end
end)


addHook("PlayerThink", function(player)
      if player.valid and player.playerstate == PST_LIVE
         if player.mo.skin == "sonic"
         and (player.pflags & PF_JUMPED)
		 and (player.powers[pw_underwater])
		 and (player.cmd.buttons & BT_CUSTOM1)
            local bluespringspawn = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BLUESPRING)
	        bluespringspawn.target = player.mo
			bluespringspawn.fuse = TICRATE
	        bluespringspawn.dissappear = TICRATE
	        bluespringspawn.angle = player.drawangle
         end
	 end
end)


addHook("PlayerThink", function(player)
      if player.valid and player.playerstate == PST_LIVE
         if player.mo.skin == "sonic"
         and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		 and (player.powers[pw_underwater])
		 and (player.cmd.buttons & BT_CUSTOM1)
            local yellowspringspawn = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_YELLOWSPRING)
	        yellowspringspawn.target = player.mo
			yellowspringspawn.fuse = TICRATE
	        yellowspringspawn.dissappear = TICRATE
	        yellowspringspawn.angle = player.drawangle
         end 
	 end
end)


addHook("SpinSpecial", function(player)
	 if player.mo.skin == "sonic"
		 if (player.mo.state == S_PLAY_SPRING)
		 or (player.mo.state == S_PLAY_FALL)
		    S_StartSound(player.mo, sfx_spin)
			P_SpawnThokMobj(player)
		    player.mo.state = S_PLAY_ROLL
	     end	 
	 end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "sonic")
    and (player.mo.state == S_PLAY_ROLL)
        return true	
    end
end)